/* eslint prefer-const:0, no-var:0, react/prop-types:0, space-infix-ops:0 */
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; desc = parent = getter = undefined; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; continue _function; } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _reactAddons = require("react/addons");

var _reactAddons2 = _interopRequireDefault(_reactAddons);

var _reactComponentResizable = require("react-component-resizable");

var _reactComponentResizable2 = _interopRequireDefault(_reactComponentResizable);

var _classnames = require("classnames");

var _classnames2 = _interopRequireDefault(_classnames);

var _objectAssign = require("object.assign");

var _objectAssign2 = _interopRequireDefault(_objectAssign);

var cloneElement = _reactAddons2["default"].cloneElement;

var ContainerQuery = (function (_React$Component) {
  _inherits(ContainerQuery, _React$Component);

  function ContainerQuery(props) {
    _classCallCheck(this, ContainerQuery);

    _get(Object.getPrototypeOf(ContainerQuery.prototype), "constructor", this).call(this, props);
    this.state = {
      width: 0
    };
    this._updateWidth = this._updateWidth.bind(this);
    this._getBreakpoint = this._getBreakpoint.bind(this);
  }

  _createClass(ContainerQuery, [{
    key: "_updateWidth",
    value: function _updateWidth(dim) {
      this.setState({
        width: dim.width
      });
      if (this.refs.resizable.resetTriggers) {
        this.refs.resizable.resetTriggers();
      }
    }
  }, {
    key: "_getBreakpoint",
    value: function _getBreakpoint() {
      var breakpoint = "";
      var curBp = -1;
      for (var b in this.props.breakpoints) {
        var bp = this.props.breakpoints[b];
        if (this.state.width > bp) {
          if (bp > curBp) {
            breakpoint = b;
            curBp = bp;
          }
        }
      }
      return breakpoint;
    }
  }, {
    key: "_renderChild",
    value: function _renderChild(breakpoint, child, index) {
      if (!child.props) {
        return child;
      }

      var props = {
        key: index
      };

      if (child.props["style-" + breakpoint]) {
        props.style = (0, _objectAssign2["default"])(child.props.style || {}, child.props["style-" + breakpoint]);
      }

      if (child.props["className-" + breakpoint]) {
        props.className = (0, _classnames2["default"])(child.props.className, child.props["className-" + breakpoint]);
      }

      if (child.props["props-" + breakpoint]) {
        props = (0, _objectAssign2["default"])(props, child.props["props-" + breakpoint]);
      }

      return cloneElement(child, props);
    }
  }, {
    key: "render",
    value: function render() {
      var _this = this;

      var breakpoint = this._getBreakpoint();
      var ResizableComp = this.props.resizableContainer;
      return _reactAddons2["default"].createElement(
        ResizableComp,
        {
          className: this.props.className,
          style: this.props.style,
          onResize: this._updateWidth,
          ref: "resizable" },
        _reactAddons2["default"].Children.map(this.props.children, function (child, index) {
          return _this._renderChild(breakpoint, child, index);
        })
      );
    }
  }]);

  return ContainerQuery;
})(_reactAddons2["default"].Component);

exports["default"] = ContainerQuery;

ContainerQuery.PropTypes = {
  breakpoints: _reactAddons2["default"].PropTypes.object.isRequired,
  resizableContainer: _reactAddons2["default"].PropTypes.component
};

ContainerQuery.defaultProps = {
  resizableContainer: _reactComponentResizable2["default"]
};
module.exports = exports["default"];